﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
using Telerik.Web.UI;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;
using System.Text.RegularExpressions;

public partial class ComboScripts : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            BindReason();

    }
    protected void BindReason()
    {
        SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
        string filterString = string.Empty;
        SqlCommand selectCommand = new SqlCommand(
        @" SELECT * FROM Categories WHERE (CategoryName) LIKE '" + filterString + "%'", connection);
        SqlDataAdapter adapter = new SqlDataAdapter(selectCommand);
        DataTable products = new DataTable();
        adapter.Fill(products);
        cboReason.DataSource = products;
        cboReason.DataTextField = "CategoryName";
        cboReason.DataValueField = "CategoryId";
        cboReason.DataBind();
    }

    private void BindGrid()
    {

        SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
        string filterString = string.Empty;
        SqlCommand selectCommand = new SqlCommand(
        @" SELECT * FROM Products WHERE (ProductName) LIKE '" + filterString + "%'", connection);
        SqlDataAdapter adapter = new SqlDataAdapter(selectCommand);
        DataTable products = new DataTable();
        adapter.Fill(products);
        rgAllowance.DataSource = products;
        //rgAllowance.DataBind();

    }
    private void ClearData()
    {
        //Need to clear checkbox on Server side , since IE and Firedfox not working with client side
        chkByTime.Checked = false;
        //chkByNRM.Checked = false;
        //chkByNRMOT.Checked = false;
        //chkByOT.Checked = false;
        //chkByActWkHr.Checked = false;
        chkByReason.Checked = false;
        chkNoPayReason.Checked = false;
        chkByDay.Checked = false;
        chkMon.Checked = false;
        chkTue.Checked = false;
        chkWed.Checked = false;
        chkThurs.Checked = false;
        chkFri.Checked = false;
        chkSat.Checked = false;
        chkSun.Checked = false;
        cboReason.ClearCheckedItems();
    }

    protected void RadAjaxManager1_AjaxRequest(object sender, AjaxRequestEventArgs e)
    {
        //BindReason();
        string valueStr = e.Argument.ToString();
        char[] splitter = new char[] { ',' };
        string[] valueArray = valueStr.Split(splitter);

        string type = valueArray[0];
        string valID = valueArray[1];

        string temp = string.Empty;
        temp = "";

        ClearData();

        if (type.Equals("Edit"))
        {

        }
        else if (type.Equals("New"))
        {

            lblMessage.Text = "";
            txtAllowanceCd.Enabled = true;
            txtAllowanceCd.Text = "";
            txtAllowanceName.Text = "";
            txtAllowanceAmt.Text = "";
            chkByTime.Checked = false;
            txtFr.Text = "";
            txtTo.Text = "";
            chkByReason.Checked = false;
            chkNoPayReason.Checked = false;
            chkByDay.Checked = false;
            chkMon.Checked = false;
            chkTue.Checked = false;
            chkWed.Checked = false;
            chkThurs.Checked = false;
            chkFri.Checked = false;
            chkSat.Checked = false;
            chkSun.Checked = false;


        }
        else if (type.Equals("Refresh"))
        {
            BindGrid();
        }
    }
    protected void rgdAllowance_PreRender(object sender, EventArgs e)
    {
        try
        {
            if ((sender as RadGrid).SelectedItems.Count > 0)
            {

                if (rgAllowance.SelectedValue != null)
                {
                    string regis_id = rgAllowance.SelectedValue.ToString();
                    hid_f.Value = regis_id;
                }
            }
        }
        catch
        {
            hid_f.Value = "0";
        }
    }
    protected void rgAllowance_OnNeedDataSource(object sender, EventArgs e)
    {
        BindGrid();
        rgAllowance.SelectedIndexes.Add(0);
    }
    protected void btnSave_Click(object sender, EventArgs e)
    {
        string finalReasonCodes = string.Empty;

        var collection = cboReason.CheckedItems;
        string text = string.Empty;
        if (collection.Count != 0)
        {
            foreach (var item in collection)
            {
                text = item.Text;
            }
        }

    }
    protected void Check_NRMOTClicked(Object sender, EventArgs e)
    {
        if (chkByNRMOT.Checked == true)
        {
            chkByNRM.Checked = true;
            chkByOT.Checked = true;
            txtNRM.Text = "";
            chkByNRM.Enabled = false;
            chkByOT.Enabled = false;
            cboByNRMCond.Enabled = false;
            txtNRM.Enabled = false;
        }
        else
        {

            chkByNRM.Enabled = true;
            chkByOT.Enabled = true;
            cboByNRMCond.Enabled = true;
            txtNRM.Enabled = true;


        }
    }
    protected void formatValidation(object source, ServerValidateEventArgs arguments)
    {
        lblMessage.Text = "";

        Regex regex = new Regex("^(?:0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]|(?:0[0-9]|1[0-9]|2[0-3])[0-5][0-9]$");
        if (!regex.IsMatch(txtFr.Text) && txtFr.Text != "")
        {
            arguments.IsValid = false;
            lblMessage.Text = "Wrong format for From time";
            txtFr.Focus();
            return;
        }

        if (!regex.IsMatch(txtTo.Text) && txtTo.Text != "")
        {
            arguments.IsValid = false;
            lblMessage.Text = "Wrong format for To time";
            txtTo.Focus();
            return;
        }

        regex = new Regex(@"^\d+(\.\d{1,2})?$");
        if (!regex.IsMatch(txtAllowanceAmt.Text) && txtAllowanceAmt.Text != "")
        {
            arguments.IsValid = false;
            lblMessage.Text = "Wrong format for allowance amount";
            txtAllowanceAmt.Focus();
            return;
        }

        if (!regex.IsMatch(txtNRM.Text) && txtNRM.Text != "")
        {
            arguments.IsValid = false;
            lblMessage.Text = "Wrong format for work hours";
            txtNRM.Focus();
            return;
        }

        if (!regex.IsMatch(txtOT.Text) && txtOT.Text != "")
        {
            arguments.IsValid = false;
            lblMessage.Text = "Wrong format for OT hours";
            txtOT.Focus();
            return;
        }

        if (!regex.IsMatch(txtActHr.Text) && txtActHr.Text != "")
        {
            arguments.IsValid = false;
            lblMessage.Text = "Wrong format for actual hours ";
            txtActHr.Focus();
            return;
        }

    }
}